unit TestContourUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  TeEngine, TeeSurfa, ExtCtrls, TeeProcs, Chart, StdCtrls, Buttons;

type
    TStr2Extended = record
       val: extended;
       err_code: integer;
    end;

type
  TForm1 = class(TForm)
    Chart1: TChart;
    BitBtn1: TBitBtn;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    Memo1: TMemo;
    Series1: TContourSeries;
    procedure FormCreate(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
  private
    { Dclarations prives }

  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation
var  datafile: textfile; x,y,z: double;

{$R *.DFM}
function Str2Num(var s: string): TStr2Extended;
var i: integer; tmp: real;
begin
 repeat
   for i:=1 to length(s) do begin
     if NOT(s[i] IN ['0'..'9','.',',','-','E','e']) then delete(s,i,1);
     if s[i]=',' then s[i]:='.';
   end;
   val(s,tmp,i);
   if i>0 then delete(s,i,1);
 until (i=0) OR (length(s)<1) OR (s[i] IN ['e','E']);
 result.val:= tmp;
 result.err_code:= i;
end;

function Num2Str(v: extended; i,j: byte): shortstring;
var s: shortstring;
begin
  str(v:i:j,s); result:= s;
end;

Function RandomXYZ(x,z:Integer):Double;

  Function ToAngle(Value:Integer):Double;
  begin
    result:=((Value+10)*18.0)*Pi/180.0;
  end;

begin
  result:= 0.4 + 0.1*x - 0.1*z + 0.8*x*z + 0.2*x*x*x -0.2*z*z*z ;
end;

procedure TForm1.FormCreate(Sender: TObject);
var x,z:Integer;
begin
 inherited;
 With Series1 do
  begin
    Clear;
    for x:= -10 to 10 do
        for z:= -10 to 10 do
            AddXYZ( x, RandomXYZ(x,z) ,z, '', clTeeColor);
  end;

  Series1.NumLevels:=20;
  Chart1.Chart3DPercent:=100;
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
var cnt,cnt2: word;
begin
     inherited;
     if OpenDialog1.execute then begin
        AssignFile(Datafile,OpenDialog1.filename);
        Reset(Datafile);
        Series1.clear;
        Series1.IrregularGrid:= true;
        cnt:= 0;
        while not(eof(Datafile)) do begin
              Readln(Datafile,x,y,z);
              Series1.AddXYZ(x,z,z,'',clTeeColor);
              Memo1.Lines.Add(Num2Str(cnt,0,0)+' '+Num2Str(x,2,2) + ' ' + Num2Str(y,2,2) +' ' +Num2Str(z,2,2));
              inc(cnt);
        end; // end of eof()
        CloseFile(Datafile);
     end; // end of ReadFile
     Series1.NumLevels:=20;
     Chart1.Chart3DPercent:=100;
end;

end.
